;aplikace RFM02 vysla na zapnut cirkulace TUV

;procesor PIC16F505, WDT off, EC(1 MHz;krystal RFM=10MHz, 
;
;Vyle zprvu ve formtu AA,AA,AA,2D,D4,Data0 a Data15,CRC,AA.
;16_byte rozliovac kd.
;Prvnch 8_byte dat je pro tyto vyslae vdy stejn,oznauj toto zazen.
;Dalch 8_byte dat je jedinen programovanch v kadm vyslai.

       LIST P=16F505
#include       "p16f505.inc"
TX_REG      equ     10		;promnn
CMD_hi	    equ     11
CMD_lo	    equ     12
CNT			equ     13
DEL1		equ		14
DEL2		equ		15
TIME		equ		16

;uivatelsky definovan hodnoty, pro kad vysla jin
hodnota_8	equ		19		;vkldm data pro 1. pijma (spoutn cirkulace TUV)
hodnota_9	equ		1A		
hodnota_10	equ		1B
hodnota_11	equ		1C
hodnota_12	equ		1D
hodnota_13	equ		1E
hodnota_14	equ		1F
hodnota_15	equ		23		

chksum		equ		84

;END uivatelsky definovanch hodnot

;ICSPDATA			PORTB,0	;in
;ICSPCLK			PORTB,1	;in
;			nic		PORTB,2	;in
#define     nIRQ    PORTB,3	;in
#define     FSK		PORTB,4	;out
;					PORTB,5	;CLK in

;		    nic		PORTC,0	;in
#define		OPTO	PORTC,1	;out
#define     LED		PORTC,2	;out
#define		SDI		PORTC,3	;out
#define		nSEL	PORTC,4	;out
#define		SCK		PORTC,5	;out



			ORG     0
			GOTO    INIT
;-----------
MAIN    	CLRWDT
			MOVLW	0x00
			MOVWF	CMD_lo
			MOVLW	0xCC
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x61		;config comm.(band 868,clock 10MHz)
			MOVWF	CMD_lo
			MOVLW	0x97
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x40
			MOVWF	CMD_lo
			MOVLW	0xA6
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x23
			MOVWF	CMD_lo
			MOVLW	0xC8
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x20
			MOVWF	CMD_lo
			MOVLW	0xC2
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x00
			MOVWF	CMD_lo
			MOVLW	0xC0
			MOVWF	CMD_hi
			CALL	WriteCMD


			MOVLW	0x3		;poet opakovn dvky
			MOVWF	TIME

PA_ON		MOVLW	0x38
			MOVWF	CMD_lo
			MOVLW	0xC0
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0xAA
			CALL	WriteFSK
			MOVLW	0xAA
			CALL	WriteFSK
			MOVLW	0xAA
			CALL	WriteFSK
			MOVLW	0x2D
			CALL	WriteFSK
			MOVLW	0xD4
			CALL	WriteFSK

			MOVLW	0x54
			CALL	WriteFSK
			MOVLW	0x68
			CALL	WriteFSK
			MOVLW	0x52
			CALL	WriteFSK
			MOVLW	0x59
			CALL	WriteFSK
			MOVLW	0x56
			CALL	WriteFSK
			MOVLW	0x87
			CALL	WriteFSK
			MOVLW	0x52
			CALL	WriteFSK
			MOVLW	0x07
			CALL	WriteFSK
			MOVLW	hodnota_8
			CALL	WriteFSK
			MOVLW	hodnota_9
			CALL	WriteFSK
			MOVLW	hodnota_10
			CALL	WriteFSK
			MOVLW	hodnota_11
			CALL	WriteFSK
			MOVLW	hodnota_12
			CALL	WriteFSK
			MOVLW	hodnota_13
			CALL	WriteFSK
			MOVLW	hodnota_14
			CALL	WriteFSK
			MOVLW	hodnota_15
			CALL	WriteFSK
			MOVLW	chksum
			CALL	WriteFSK
			MOVLW	0xAA
			CALL	WriteFSK

PA_OFF		MOVLW	0x00
			MOVWF	CMD_lo
			MOVLW	0xC0
			MOVWF	CMD_hi
			CALL	WriteCMD

			CALL	Delay
			DECFSZ	TIME
			GOTO	PA_ON
;konec vysln, vypni napjen
			BCF		OPTO
			GOTO	$-1
;==========================
WriteFSK	MOVWF	TX_REG
		
TST_n7L		BTFSS	nIRQ		;bit7
			GOTO	TST_n7L
TST_n7H		BTFSC	nIRQ
			GOTO	TST_n7H
			BTFSS	TX_REG,7
			BCF		FSK
			BTFSC	TX_REG,7
			BSF		FSK
			RLF		TX_REG,F

TST_n6L		BTFSS	nIRQ		;bit6
			GOTO	TST_n6L
TST_n6H		BTFSC	nIRQ
			GOTO	TST_n6H
			BTFSS	TX_REG,7
			BCF		FSK
			BTFSC	TX_REG,7
			BSF		FSK
			RLF		TX_REG,F

TST_n5L		BTFSS	nIRQ		;bit5
			GOTO	TST_n5L
TST_n5H		BTFSC	nIRQ
			GOTO	TST_n5H
			BTFSS	TX_REG,7
			BCF		FSK
			BTFSC	TX_REG,7
			BSF		FSK
			RLF		TX_REG,F

TST_n4L		BTFSS	nIRQ		;bit4
			GOTO	TST_n4L
TST_n4H		BTFSC	nIRQ
			GOTO	TST_n4H
			BTFSS	TX_REG,7
			BCF		FSK
			BTFSC	TX_REG,7
			BSF		FSK
			RLF		TX_REG,F

TST_n3L		BTFSS	nIRQ		;bit3
			GOTO	TST_n3L
TST_n3H		BTFSC	nIRQ
			GOTO	TST_n3H
			BTFSS	TX_REG,7
			BCF		FSK
			BTFSC	TX_REG,7
			BSF		FSK
			RLF		TX_REG,F

TST_n2L		BTFSS	nIRQ		;bit2
			GOTO	TST_n2L
TST_n2H		BTFSC	nIRQ
			GOTO	TST_n2H
			BTFSS	TX_REG,7
			BCF		FSK
			BTFSC	TX_REG,7
			BSF		FSK
			RLF		TX_REG,F

TST_n1L		BTFSS	nIRQ		;bit1
			GOTO	TST_n1L
TST_n1H		BTFSC	nIRQ
			GOTO	TST_n1H
			BTFSS	TX_REG,7
			BCF		FSK
			BTFSC	TX_REG,7
			BSF		FSK
			RLF		TX_REG,F

TST_n0L		BTFSS	nIRQ		;bit0
			GOTO	TST_n0L
TST_n0H		BTFSC	nIRQ
			GOTO	TST_n0H
			BTFSS	TX_REG,7
			BCF		FSK
			BTFSC	TX_REG,7
			BSF		FSK

			RETLW	0
;-------------
WriteCMD	MOVLW   10
			MOVWF   CNT
			BCF		SCK
			BCF		nSEL
			GOTO	LOOP_1
LOOP_2		BTFSS	CMD_hi,7
			GOTO	WR_0
WR_1		BSF		SDI
			BCF		SCK
			NOP
			BSF		SCK
			NOP
			GOTO	LOOP_3
WR_0		BCF		SDI
			BCF		SCK
			NOP
			BSF		SCK
			NOP
LOOP_3		RLF		CMD_lo,F
			RLF		CMD_hi,F
LOOP_1		DECF	CNT,F
			INCFSZ	CNT,W
			GOTO	LOOP_2
			BCF		SCK
			BSF		nSEL
			RETLW	0
;------------- 
Delay		MOVLW	0x18
			MOVWF	DEL2
D0			CALL	DELAY1
			DECF	DEL2,F
			INCFSZ	DEL2,W
			GOTO	D0
			RETLW	0
;-----------------

DELAY1		CLRF	DEL1
D1			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			DECFSZ	DEL1,F
			GOTO	D1
			RETLW	0
;-----------------
INIT    CLRF   	PORTB
		MOVLW   B'11011001'		;RC5(SCK)=0,RC4(nSEL)=1,RC3(SDI)=1
		MOVWF   PORTC			;RC2(LED)=0,RC1(OPTO)=0,RC0(nic)=1
		MOVLW   B'11011111'     ;TOCS=0,prescaller 1:128 to WDT
		OPTION

		MOVLW   B'11101111'     ;B5=osc.in,B4=out,B3=in,B2=in,B1=in,B0=in
		TRIS	6
		MOVLW   B'11000001'     ;C5=out,C4=out,C3=out,C2=out,C1=out,C0=in
		TRIS	7

		BSF		OPTO			;zapni napjen	
		BSF		LED				;blikni LED
		CALL	Delay			;pauza cca 0,3sec
		BCF		LED
		GOTO    MAIN
;-----------
		END
